<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '~/mixins';

export default Vue.extend({
  name: 'SeriesHeader',
  mixins: [IsMobileMixin],
  props: {
    header: {
      type: String,
      required: false,
      default: '',
    },
    activeFilter: {
      type: Boolean,
      required: false,
      default: false,
    },
    selected: {
      type: String,
      required: false,
      default: 'All regions',
    },
    filterOptions: {
      type: Array as () => Array<string>,
      required: false,
      default: () => [''],
    },
  },
  data() {
    return {
      selectedFilter: 'All regions',
    };
  },
  computed: {
    cols() {
      return this.isMobile ? 12 : 4;
    },
  },
  watch: {
    selectedFilter() {
      this.updateSelected();
    },
  },
  methods: {
    updateSelected() {
      this.$emit('update:selected', this.selectedFilter);
    },
  },
});
</script>

<template>
  <div>
    <div class="decorator" />
    <div class="header-container">
      <SlpTypography
        v-show="header"
        tag="h2"
        variant="heading2-bold"
        class="slp-py-16"
      >
        {{ header }}
      </SlpTypography>

      <SlpRow
        v-if="activeFilter && selected !== '' && !header.includes('APAC')"
        class="dropdown-container"
      >
        <SlpColumn :cols="cols" size="lg">
          <SlpDropdown
            v-model="selectedFilter"
            name="regions"
            :options="filterOptions"
          >
          </SlpDropdown>
        </SlpColumn>
      </SlpRow>
    </div>

    <slot></slot>
  </div>
</template>

<style lang="scss" scoped>
.decorator {
  width: 95px;
  height: 4px;
  border-radius: 10px;
  background: linear-gradient(
    89.95deg,
    #feb484 3.13%,
    #a686f2 66.86%,
    #592ac8 123.2%
  );
}

.dropdown-container {
  margin: $spacing-16 0;
  & > * {
    width: 100%;
  }
}
</style>
